package servo;

//derived from SUN's examples in the javax.comm package
import java.io.*;
import java.util.*;
//import javax.comm.*; // for SUN's serial/parallel port libraries
import game.Punto;
import gnu.io.*; // for rxtxSerial library

public class TestFunzionante implements Runnable, SerialPortEventListener {
   static CommPortIdentifier portId;
   static CommPortIdentifier saveportId;
   static Enumeration        portList;
   InputStream           inputStream;
   SerialPort           serialPort;
   Thread           readThread;
   
   private ArrayList<Integer> tilt= new ArrayList<Integer>();
   private ArrayList<Integer> pan= new ArrayList<Integer>();
   
   int n=0;
   
   static String        messageString = "Scc\r\n";
   static PrintStream      outputStream;
   static boolean        outputBufferEmptyFlag = false;

   public static void main(String[] args) {
      boolean           portFound = false;
      String           defaultPort;
      
      // determine the name of the serial port on several operating systems
      String osname = System.getProperty("os.name","").toLowerCase();
      if ( osname.startsWith("windows") ) {
         // windows
         defaultPort = "COM8";
      } else if (osname.startsWith("linux")) {
         // linux
        defaultPort = "/dev/ttyUSB0";
      } else if ( osname.startsWith("mac") ) {
         // mac
         defaultPort = "????";
      } else {
         System.out.println("Sorry, your operating system is not supported");
         return;
      }
          
      if (args.length > 0) {
         defaultPort = args[0];
      } 

      System.out.println("Set default port to "+defaultPort);
      
		// parse ports and if the default port is found, initialized the reader
      portList = CommPortIdentifier.getPortIdentifiers();
      while (portList.hasMoreElements()) {
         portId = (CommPortIdentifier) portList.nextElement();
         if (portId.getPortType() == CommPortIdentifier.PORT_SERIAL) {
            if (portId.getName().equals(defaultPort)) {
               System.out.println("Found port: "+defaultPort);
               portFound = true;
               // init reader thread
               TestFunzionante reader = new TestFunzionante();
            } 
         } 
         
      } 
      if (!portFound) {
         System.out.println("port " + defaultPort + " not found.");
      } 
      
   } 
   
   public void initPosition() {
	   /*
	   posizioni.add("Saa\r");
	   posizioni.add("S92\r");
	   posizioni.add("SA0\r");
	   posizioni.add("SPn\r");
	   posizioni.add("S&)\r");
	   posizioni.add("Sf%\r");
	   posizioni.add("Slq\r");
	   */
	   //String s;
	   System.out.println("prima");
	   for (int p=0;p<101;p+=10){
		   for (int t=90;t<181;t+=10){
			   //s="S"+pan+tilt+"\r";
			   tilt.add(new Integer(t));
			   pan.add(new Integer(p));
		   }
   		}
	   System.out.println("dopo");
   }

   public void initwritetoport() {
      // initwritetoport() assumes that the port has already been opened and
      //    initialized by "public nulltest()"

      try {
         // get the outputstream
         outputStream = new PrintStream(serialPort.getOutputStream(), true);
      } catch (IOException e) {}

      try {
         // activate the OUTPUT_BUFFER_EMPTY notifier
         serialPort.notifyOnOutputEmpty(true);
      } catch (Exception e) {
         System.out.println("Error setting event notification");
         System.out.println(e.toString());
         System.exit(-1);
      }
      
   }

   public void writetoport() {
      
	   String pos = getPosizioneRandom();
	   int tilt;
	   int pan;
	   pan=(int)pos.getBytes()[1];	   
	   tilt=(int)pos.getBytes()[2];
	   
	   System.out.println("Writing " + pos +" pan: "+pan+" tilt: "+tilt+"to "+serialPort.getName());
      // write string to serial port
	 outputStream.print(pos);
   }
   
   public String getPosizioneRandom() {
		
		//Random ran=new Random();
		//int n=ran.nextInt(posizioni.size());
	   
		System.out.printf("scelto %d\n",n);
		int t=tilt.get(n);
		int pa=pan.get(n);
		byte tb=(byte)(t & 0xff);
		byte pb=(byte)(pa & 0xff);
		char ss[]=new char[4];
		ss[0]=(char)('S');
		ss[1]=(char)pa;
		ss[2]=(char)t;
		ss[3]=(char		)'\r';
		
		String p=new String(ss);
		n++;
		if(n==pan.size())n=0;
		return p;
	}

   public TestFunzionante() {
      // initalize serial port
      try {
         serialPort = (SerialPort) portId.open("SimpleReadApp", 2000);
      } catch (PortInUseException e) {}
   
      try {
         inputStream = serialPort.getInputStream();
      } catch (IOException e) {}
   
      try {
         serialPort.addEventListener(this);
      } catch (TooManyListenersException e) {}
      
      // activate the DATA_AVAILABLE notifier
      serialPort.notifyOnDataAvailable(true);
   
      try {
         // set port parameters
         serialPort.setSerialPortParams(115200, SerialPort.DATABITS_8, 
                     SerialPort.STOPBITS_1, 
                     SerialPort.PARITY_NONE);
      } catch (UnsupportedCommOperationException e) {}
      
      // start the read thread
      readThread = new Thread(this);
      readThread.start();
      
   }

   public void run() {
      // first thing in the thread, we initialize the write operation
	  initPosition();
      initwritetoport();
      try {
         while (true) {
            // write string to port, the serialEvent will read it
            writetoport();
            Thread.sleep(3000);
         }
      } catch (InterruptedException e) {}
   } 

   public void serialEvent(SerialPortEvent event) {
      switch (event.getEventType()) {
      case SerialPortEvent.BI:
      case SerialPortEvent.OE:
      case SerialPortEvent.FE:
      case SerialPortEvent.PE:
      case SerialPortEvent.CD:
      case SerialPortEvent.CTS:
      case SerialPortEvent.DSR:
      case SerialPortEvent.RI:
      case SerialPortEvent.OUTPUT_BUFFER_EMPTY:
         break;
      case SerialPortEvent.DATA_AVAILABLE:
         // we get here if data has been received
         byte[] readBuffer = new byte[20];
         try {
            // read data
            while (inputStream.available() > 0) {
               int numBytes = inputStream.read(readBuffer);
            } 
            // print data
            String result  = new String(readBuffer);
            System.out.println("Read: "+result);
         } catch (IOException e) {}
   
         break;
      }
   } 

}
